"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = connectCallback;

var _DependencyMap = require("../dependencies/DependencyMap");

var _Dispatch = require("./Dispatch");

var _DispatcherInstance = require("../dispatcher/DispatcherInstance");

var _DispatcherInterface = require("../dispatcher/DispatcherInterface");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function subscribe(dependencies, dependencyIndex, dispatcher, callback) {
  var props = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
  var state = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : null;
  var dispatchToken;
  var storeState = {};

  function remove() {
    if (dispatchToken) {
      dispatcher.unregister(dispatchToken);
      dispatchToken = null;
    }
  }

  function handleUpdate(entry) {
    var prevStoreState = storeState;

    try {
      storeState = _objectSpread(_objectSpread({}, prevStoreState), (0, _DependencyMap.calculateForDispatch)(dependencies, entry, props, state));
      callback(null, storeState, prevStoreState, remove);
    } catch (error) {
      remove();
      callback(error, storeState, prevStoreState, remove);
    }
  }

  dispatchToken = dispatcher.register(_Dispatch.handleDispatch.bind(null, dispatcher, dependencyIndex, handleUpdate));

  try {
    storeState = (0, _DependencyMap.calculateInitial)(dependencies, props, state);
    callback(null, storeState, {}, remove);
  } catch (error) {
    remove();
    callback(error, storeState, {}, remove);
  }

  return {
    remove: remove
  };
}

function connectCallback(dependencies) {
  var dispatcher = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : (0, _DispatcherInstance.get)();
  (0, _DispatcherInterface.enforceDispatcher)(dispatcher);

  if (!dispatcher) {
    return null;
  }

  return subscribe.bind(null, dependencies, (0, _DependencyMap.makeDependencyIndex)(dependencies), dispatcher);
}