"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.get = get;
exports.set = set;
exports.clear = clear;

var _DispatcherInterface = require("./DispatcherInterface");

var _invariant = _interopRequireDefault(require("invariant"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var instance = null;

function get() {
  return instance;
}

function set(dispatcher) {
  (0, _invariant.default)((0, _DispatcherInterface.isDispatcher)(dispatcher), 'DispatcherInstance.set: Expected dispatcher to be an object' + ' with a register method, and an unregister method but got "%s".' + ' Learn more about the dispatcher interface:' + ' https://github.com/HubSpot/general-store#dispatcher-interface', dispatcher);
  instance = dispatcher;
}

function clear() {
  var oldInstance = instance;
  instance = null;
  return oldInstance;
}