"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isDispatcher = isDispatcher;
exports.enforceDispatcher = enforceDispatcher;
exports.isPayload = isPayload;

var _invariant = _interopRequireDefault(require("invariant"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function isDispatcher(dispatcher) {
  return !!dispatcher && _typeof(dispatcher) === 'object' && typeof dispatcher.register === 'function' && typeof dispatcher.unregister === 'function';
}

function enforceDispatcher(dispatcher) {
  (0, _invariant.default)(isDispatcher(dispatcher), 'expected `dispatcher` to be a `Flux.Dispatcher` or compatible object but' + 'got `%s` Learn more about the dispatcher interface:' + ' https://github.com/HubSpot/general-store#dispatcher-interface', dispatcher);
}

function isPayload(payload) {
  return payload !== null && _typeof(payload) === 'object' && (typeof payload.actionType === 'string' || typeof payload.type === 'string');
}